"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ngAdd = void 0;
const schematics_1 = require("@angular-devkit/schematics");
const tasks_1 = require("@angular-devkit/schematics/tasks");
const change_1 = require("@schematics/angular/utility/change");
const ts = require("typescript");
const ast_utils_1 = require("../utility/ast-utils");
function ngAdd() {
    return (tree, context) => {
        context.logger.info('Installing dependencies...');
        context.addTask(new tasks_1.NodePackageInstallTask());
        context.logger.info('Adding LazyDialogModule to the app...');
        const appModulePath = './src/app/app.module.ts';
        if (!tree.exists(appModulePath)) {
            throw new schematics_1.SchematicsException(`The file ${appModulePath} doesn't exist...`);
        }
        const recorder = tree.beginUpdate(appModulePath);
        const appModuleFileContent = tree.read(appModulePath);
        if (appModuleFileContent === null) {
            throw new schematics_1.SchematicsException(`The content of ${appModulePath} couldn't be read...`);
        }
        const appModuleFileText = appModuleFileContent.toString('utf-8');
        const sourceFile = ts.createSourceFile(appModulePath, appModuleFileText, ts.ScriptTarget.Latest, true);
        (0, change_1.applyToUpdateRecorder)(recorder, (0, ast_utils_1.addSymbolToNgModuleMetadata)(sourceFile, appModulePath, 'imports', 'LazyDialogModule', '@ngx-toolset/lazy-dialogs', 'LazyDialogModule.forRoot({})'));
        tree.commitUpdate(recorder);
        return tree;
    };
}
exports.ngAdd = ngAdd;
//# sourceMappingURL=index.js.map